import { StepInfoNode } from "../model/tactic/Tactic"

export function addStepNode(
    root: StepInfoNode,
    parent: StepInfoNode,
    child: StepInfoNode,
): StepInfoNode {
    if (root.id === parent.id) {
        return {
            ...root,
            children: root.children.concat(child),
        }
    }

    return {
        ...root,
        children: root.children.map((c) => addStepNode(c, parent, child)),
    }
}

export function removeStepNode(
    root: StepInfoNode,
    node: StepInfoNode,
): StepInfoNode | null {
    if (root.id === node.id) {
        return null
    }

    return {
        ...root,
        children: root.children.flatMap((child) => {
            const result = removeStepNode(child, node)
            return result ? [result] : []
        }),
    }
}
